
;*****************************  ATtiny 2313*****************************

;*   - 4,096 
;* ;
;* Main:        
;* Display:       ,   -  
;* UnitSD:        ,   - 
;* DisplayEE:     ,     EEPROM
;* Speed:        
;* CalcStep:       , ()
;* CalcSpeed:    , /
;* CalcSpeed2:   , /
;* CountStep:     
;* Timer_Int1:    1,  
;* Timer_Int0:    0,  
;* Code_5:            
;* Code_3:           /
;* Code_31:           
;* HexBCD:        BCD - 
;* MUL42:       
;* DIV42:       
;* Sound:         
;* Sound2:       
;* WriteEEPROM:       EEPROM
;* WriteDisSP:   EEPROM   
;* EEWrite:	    "  EEPROM"
;* EERead:	    " EEPROM"
;* Kath:         
;* FUSES:      BODLEVEL = 101, CKSEL = 1101, SUT = 01
;* ;     STEP-V1.2
;*******************************************************************************

.nolist
.include "tn2313def.inc"
.list

;***** *****

.def	m0 = r1        ;  /   
.def	m1 = r2     
.def	m2 = r3      
.def	m3 = r4      
.def	m4 = r5      
.def	m5 = r6      
.def	m6 = r7
.def	m7 = r8      
.def	StepL = r9     ;  ,  
.def	HexL = r10     ;    
.def	HexH = r11     ;    
.def	Save = r12     ;   SREG  
.def    StepH= r13     ;  ,   
.def    EEdwr = r14    ;    EEPROM
.def	EEdrd = r15    ;    EEPROM
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	KathS = r18    ;     
.def	Cnt =  r19     ;   
.def	DPtr = r20     ;    
.def	BCD0 = r21     ;  1  2  BCD - 
.def	BCD1 = r22     ;  3  4  BCD - 
.def	BCD2 = r23     ;  5  6  BCD - 
.def	time = r24     ;   
.def	Cnt2 = r25     ;   
             

;*****  *****

.equ	RAM	=$060
.equ	Interval= 243   ;    T0
.equ    TimeL =0        ;    T1
.equ    TimeH =256-235

.cseg

.org 0
	rjmp Initial

.org 5                    
    rjmp Timer_Int1       ; Timer0 Overflow Handler, 

.org 6
	rjmp Timer_Int0       ; Timer0 Overflow Handler, 

Initial:	
	
	ldi	t1,(RAMEND)	    ;  
	out	SPL,t1
	
   	ldi	t1,0b00101111  
	out	PORTD,t1        ;   
	ldi	t1,0b00000000		
	out	DDRD,t1		    ; PD4,PD6 -  , .0
    ldi	t1,0
    out	PORTB,t1        ;  B  
	ldi t1,$FF	
	out	DDRB,t1         
	clr DPtr
	ldi t1,0
	sts D0,t1           ;    
	sts D1,t1
	sts D2,t1
	sts D3,t1
    sts D4,t1
	sts D5,t1
	sts D6,t1
    sts D7,t1
	sts S0,t1
    sts S1,t1
	sts S2,t1
	sts S3,t1
	sts S4,t1
	sts S5,t1
	ldi YL,$0A          ;   EEPROM
    ldi	t1,5		    ;      T0
	out	TCCR0B,t1	    ;  1024 (Ck/1024 prescaling)
    rcall EERead        ;      EEPROM
	rjmp Main 
	 
Wait50us:	    ;    = 4,096 
ldi   time,65	;  
Wait51:
dec   time
brne  Wait51
ret

Wait05ms:	    ;    = 4,096 
ldi   t2,10	    ;  
Wait502:
rcall wait50us
dec   t2
brne  Wait502
ret

Wait075ms:	    ;    = 4,096 
ldi   t2,15	    ;  
Wait507:
rcall wait50us
dec   t2
brne  Wait507
ret

Wait250:        	;   0,45 
ldi   t1,0	        ;   
out   TCNT0,t1  	;  T/C0
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1	    ;   TOV0
ldi   time,7	    ; 7   
Wait:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1    	;   TOV0
dec   time
brne  Wait	        ; 7  = 0,45 
ret

Wait500:        	;   0,5 

ldi   t1,248	    ;   
out   TCNT1H,t1  	;  T/C1
ldi   t1,0
out   TCNT1L,t1
ldi   t1,1<<TOV1	;     TOV1
out   TIFR,t1	    ;   TOV1
ldi t1,5            ;     1024  T1
out TCCR1B,t1       ;    4096000/1024 = 4000 Hz
Wait2:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV1	    ;   ,   - 
rjmp  Wait2	        ;   
ldi   t1,1<<TOV1	;     TOV1
out   TIFR,t1    	;   TOV1
ldi t1,0             
out TCCR1B,t1       ;   T1 
ret

CountStep:      ;    

inc StepL          ;    Step
sts S0,StepL       ;   
mov t1,StepL
cpi t1,$FF
breq MS0           ;   
rcall Sound2       ;   
rcall Wait250      ;    
ret
MS0:
inc StepH          ;    Step
sts S1,StepH       ;   
rcall Wait250      ;    
rcall Sound2       ;   
ret

Main:    ;  

rcall Sound         ;      
rcall Wait500       ;    
cbi	DDRD,4	        ;   IC2, IC3 
ldi  t1,(0<<TOIE0)
out  TIMSK,t1       ;     T0
Main2:
clr  t1
in  t1,PIND         ;    SB1
sbrs t1,0           ;   ,    1
rjmp Display        ;      
clr  t1
in  t1,PIND         ;    SB3
sbrs t1,2           ;   ,    1
rcall Speed         ;    
clr  t1
in  t1,PIND         ;     
sbrs t1,3           ;   ,    1
rcall CountStep     ;    
clr  t1
in  t1,PIND         ;    SB4
sbrs t1,5           ;   ,    1
rcall WriteEEPROM   ;   EEPROM
sbi	PORTD,6	        ;  6-   
nop
nop
nop
clr  t1
in  t1,PIND         ;    SB5
sbrs t1,6           ;   ,    1
rcall WriteDisSP    ;   EEPROM,    
cbi	PORTD,6	        ;  6-   
rjmp Main2

Display:       ;   ,   

rcall Sound         ;     1   
rcall Wait500       ;    
	sei
    clr	t1
	out	TCCR0A,t1	    ;   0
	ldi	t1,1<<TOIE0
	out	TIMSK,t1		
	ldi	t1,Interval		;  0  10 
	out	TCNT0,t1		;    
	ldi	t1,5		    ;   
	out	TCCR0B,t1	    ;  1024 (Ck/1024 prescaling)
sbi	DDRD,4	            ;   IC2, IC3 
sbi	DDRB,4	            ;   
Display2:
rcall CalcSpeed    ;  
rcall HexBCD       ;   BCD - 
rcall Code_3       ;   
rcall CalcStep     ;   
rcall HexBCD       ;   BCD - 
rcall Code_5       ;    
clr  t1
in  t1,PIND        ;    SB1
sbrs t1,0          ;   ,    1
rjmp UnitSD        ;   2     
clr  t1
in  t1,PIND        ;    SB2
sbrs t1,1          ;   ,    1
rjmp Main          ;     
rjmp Display2

UnitSD:      ;    ,       

rcall Sound         ;     2   
rcall Wait500       ;    
rcall Sound
	sei
    clr	t1
	out	TCCR0A,t1	    ;   0
	ldi	t1,1<<TOIE0
	out	TIMSK,t1		
	ldi	t1,Interval		;  0  10 
	out	TCNT0,t1		;    
	ldi	t1,5		    ;   
	out	TCCR0B,t1	    ;  1024 (Ck/1024 prescaling)
sbi	DDRD,4	            ;   IC2, IC3 
cbi	DDRB,4	            ;   
UnitSD2:
rcall CalcSpeed2        ;    
rcall HexBCD            ;   BCD - 
rcall Code_3            ;   
lds HexL,S0             ;  ,  
lds HexH,S1             ;  ,  
rcall HexBCD            ;   BCD - 
rcall Code_5            ;    
clr  t1
in  t1,PIND        ;    SB1
sbrs t1,0          ;   ,    1
rjmp DisplayEE     ;   3     
clr  t1
in  t1,PIND        ;    SB2
sbrs t1,1          ;   ,    1
rjmp Main          ;     
rjmp UnitSD2

DisplayEE:       ;   ,     EEPROM

rcall Sound         ;     3   
rcall Wait500       ;    
rcall Sound
rcall Wait500       ;    
rcall Sound
ldi YL,1            ;   EEPROM  
rcall EERead        ;     
sts D0,EEdrd
inc YL
rcall EERead
sts D1,EEdrd
inc YL
rcall EERead
sts D2,EEdrd
inc YL
rcall EERead
sts D3,EEdrd
inc YL
rcall EERead
sts D4,EEdrd
inc YL
rcall EERead
sts D5,EEdrd
inc YL
rcall EERead
sts D6,EEdrd
inc YL
rcall EERead
sts D7,EEdrd
ldi YL,$0A              ;   EEPROM
rcall EERead            ;     EEdrd
sei
    clr	t1
	out	TCCR0A,t1	    ;   0
	ldi	t1,1<<TOIE0
	out	TIMSK,t1		
	ldi	t1,Interval		;  0  10 
	out	TCNT0,t1		;    
	ldi	t1,5		    ;   
	out	TCCR0B,t1	    ;  1024 (Ck/1024 prescaling)
sbi	DDRD,4	            ;   IC2, IC3 
sbi	DDRB,4	            ;   
DisplayEE2:
clr  t1
in  t1,PIND        ;    SB2
sbrs t1,1          ;   ,    1
rjmp Main          ;     
rjmp DisplayEE2

Timer_Int1:      ;    1
 
in Save,SREG         ;    
push t1
push t2
push time
dec Cnt2             ;        1 
cpi Cnt2,0
breq MS1
ldi  t1,TimeH        ;    1    
out  TCNT1H,t1
ldi  t1,TimeL 
out  TCNT1L,t1
pop time             ;    
pop t2
pop t1
out SREG,Save 
reti
MS1:
lds t1,S0            ;       
sts S2,t1
lds t1,S1
sts S3,t1
rcall Sound          ;     
ldi  t1,(0<<TOIE1)
out  TIMSK,t1        ;     T1
ldi t1,0             
out TCCR1B,t1        ;   T1
pop time             ;    
pop t2
pop t1
out SREG,Save 
reti
	
Timer_Int0:       ;    0
		
    in Save,SREG         ;    
    push t1
    push zl
    push zh
	ldi	t1,Interval	     ;  
	out	TCNT0,t1
    ldi zl,Low(Kath<<1)  ;   
    ldi zh,High(Kath<<1)
	clr t1
    add zl,DPtr          ;      
	adc zh,t1
	lpm                  ;   R0    
	mov KathS,r0         ;    
	andi KathS,$F0       ;    
	ldi zl,Low(D0)       ;  SRAM - 
    ldi zh,High(D0)
    add zl,DPtr          ;       
	ld t1,z              ;    SRAM - 
	andi t1,$0F          ;    
	or t1,KathS          ;    
    out	PortB,t1         ;   B   
	inc DPtr             ;   
    cpi DPtr,8           ;    
	breq MD0             ; ,  DPtr = 8
    pop zh               ;    
    pop zl
    pop t1
    out SREG,Save
	reti
MD0:
    clr DPtr             ;     
 	pop zh               ;    
    pop zl
    pop t1
    out SREG,Save         
    reti

Speed:          ;   

sei
rcall Sound         ;      
clr	t1
out	TCCR1A,t1	    ;   1 
ldi  t1,(1<<TOIE1)
out  TIMSK,t1       ;     T1
ldi  t1,TimeH       ;    1    
out  TCNT1H,t1
ldi  t1,TimeL 
out  TCNT1L,t1
ldi t1,5            ;     1024  T1
out TCCR1B,t1       ;    4096000/1024 = 4000 Hz
ldi Cnt2,20         ;       5 
lds t1,S0           ;       
sts S4,t1           ;   
lds t1,S1
sts S5,t1
rcall Wait250       ;    
ret

WriteDisSP:   ;   EEPROM   

cbi	PORTD,6	       ;  6-   
rcall Wait500      ;    
rcall Wait500
rcall Sound        ;     
rcall Wait500      ;    
rcall Wait500
ldi YL,1
lds EEdwr,D0
rcall EEWrite      ;      EEPROM
inc YL
lds EEdwr,D1
rcall EEWrite      
inc YL
lds EEdwr,D2
rcall EEWrite      
inc YL
lds EEdwr,D3
rcall EEWrite      
inc YL
lds EEdwr,D4
rcall EEWrite      
inc YL
lds EEdwr,D5
rcall EEWrite 
inc YL
lds EEdwr,D6
rcall EEWrite 
inc YL
lds EEdwr,D7
rcall EEWrite      
ldi YL,$0A         ;   EEPROM
rjmp Main          ;     

Code_5:       ;        

mov t1,BCD2
andi t1,$0F          ;   
sts D7,t1            ;   5 , (  8 )
mov t1,BCD1
andi t1,$F0          ;   
swap t1              ;  
sts D6,t1            ;   4 , (  7 )
mov t1,BCD1
andi t1,$0F          ;   
sts D5,t1            ;   3 , (  6 )
mov t1,BCD0
andi t1,$F0          ;   
swap t1              ;  
sts D4,t1            ;   2 , (  5 )
mov t1,BCD0
andi t1,$0F          ;   
sts D3,t1            ;   1 , (  4 )
ret

Code_3:       ;       /

mov t1,BCD1
andi t1,$F0          ;   
swap t1              ;  
sts D2,t1            ;   3 , (  3 )
mov t1,BCD1
andi t1,$0F          ;   
sts D1,t1            ;   2 , (  2 )
mov t1,BCD0
andi t1,$F0          ;   
swap t1              ;  
sts D0,t1            ;   1 , (  1 )
ret

Code_31:       ;      

mov t1,BCD1
andi t1,$0F          ;   
sts D2,t1            ;   3 , (  3 )
mov t1,BCD0
andi t1,$F0          ;   
swap t1              ;  
sts D1,t1            ;   2 , (  2 )
mov t1,BCD0
andi t1,$0F          ;   
sts D0,t1            ;   1 , (  1 )
ret

CalcStep:     ;     , ()
         
mov m0,EEdrd        ;      /         
ldi t1,0            ; 82  = 0,82  -    
mov m1,t1
lds m2,S0           ;     ,  
lds m3,S1           ;     ,  
ldi t1,0            ;  0   
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

ldi t1,$64          ;   100   / 
mov m0,t1             
ldi t1,0
mov m1,t1

rcall DIV42

mov hexL,m4         ;       BCD - 
mov hexH,m5         ;     
ret

MUL42:          ;  
ldi  t1,0x10

MUL1:               ; , m3:m2 * m1:m0
mov  t2,m2          ;   m7:m6:m5:m4
ror  t2           
brcc  MUL2        
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2

MUL2:
mov  t2,m7
ror  t2
mov  m7,t2
mov  t2,m6
ror  t2
mov  m6,t2
mov  t2,m5
ror  t2
mov  m5,t2
mov  t2,m4
ror  t2
mov  m4,t2
mov  t2,m3
ror  t2
mov  m3,t2
mov  t2,m2
ror  t2
mov  m2,t2
dec  t1
cpi  t1,0
brne MUL1
ret

DIV42:        ;  

ldi  t1,0x10

DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  t2,m4          ;   m5:m4
rol  t2
mov  m4,t2
mov  t2,m5
rol  t2
mov  m5,t2
mov  t2,m6
rol  t2
mov  m6,t2
mov  t2,m7
rol  t2
mov  m7,t2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  t2,m6
sbc  t2,m0
mov  m6,t2
mov  t2,m7
sbc  t2,m1
mov  m7,t2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
PER4:
dec  t1
cpi  t1,0
brne DCLK42
ret

CalcSpeed:     ;   , /

ldi t1,$24          ;   36   / 
mov m0,t1           ; 1  = 3600  /100 = 36
ldi t1,0          
mov m1,t1
lds t1,S4           ;      ,  
lds t2,S5           ;      ,  
lds m2,S2           ;      ,  
lds m3,S3           ;      ,  
sub m2,t1           ;    
sbc m3,t2
ldi t1,0            ;  0   
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

mov m0,EEdrd        ;      /         
ldi t1,0          
mov m1,t1
mov m2,m4           ;      
mov m3,m5           ;      
ldi t1,0            ;  0   
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

ldi t1,$2C          ;   300   / 
mov m0,t1           ; 5  = 300 /100 = 3  
ldi t1,$01          ; 100 * 3 = 300
mov m1,t1

rcall DIV42

mov hexL,m4         ;       BCD - 
mov hexH,m5         ;     
ret

CalcSpeed2:   ;   , /

ldi t1,$10          ;   3600   / 
mov m0,t1           ; 1  = 3600  
ldi t1,$0E
mov m1,t1
lds t1,S4           ;      ,  
lds t2,S5           ;      ,  
lds m2,S2           ;     ,  
lds m3,S3           ;     ,  
sub m2,t1           ;    
sbc m3,t2
ldi t1,0            ;  0   
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

ldi t1,$2C          ;   300   / 
mov m0,t1           ; 5  = 300 /100 = 3  
ldi t1,$01          ; 100 * 3 = 300
mov m1,t1

rcall DIV42

mov hexL,m4         ;       BCD - 
mov hexH,m5         ;   (/),   
ret

HexBCD:	    ; xxxx (Hex) -> 0abcde (BCD)
rcall Div10  	; hexH:hexL / 10,  -  tmp1
mov   BCD0,t1	;  -  hexH:hexL, tmp1 =  1
rcall Div10 	;  =  2
swap  t1	    ;  2    
or    BCD0,t1	;   2  1  BCD0
rcall Div10 	;  =  3
mov   BCD1,t1	;  BCD1
rcall Div10 	;  =  4
swap  t1	    ;  4    
or    BCD1,t1	;   4  3  BCD1
mov   BCD2,hexL ;  5 -  BCD2,   = 0
ret

Div10:	        ;  hexH:hexL  10,
                ;    hexH:hexL,  -  tmp1
clr  t1
lsl  hexL
rol  hexH
rol  t1         ;      10
lsl  hexL	    ;       
rol  hexH   	;    0
rol  t1
lsl  hexL
rol  hexH
rol  t1
ldi  Cnt,13	    ;    13 s
Loop10:
lsl  hexL	    ;     1 
rol  hexH
rol  t1     	;   tmp1
subi t1,10	    ; :  > 10 ?
brlo HB1   	    ; ,  
inc  hexL       ;     1
rjmp HB2
HB1:
subi t1,-10	    ;   
HB2:
dec  Cnt    	;   
brne Loop10 	; ,     
ret

Sound:       ;    
 
ldi XH,100
WD1:
sbi DDRD,6           ;     0
rcall Wait075ms      ;   
cbi DDRD,6           ;     1
rcall Wait075ms      ;   
dec XH
cpi XH,0
breq WD2
rjmp WD1
WD2:
ret
           
Sound2:       ;   
 
ldi XL,50
WD3:
sbi DDRD,6           ;     0
rcall Wait05ms       ;   
cbi DDRD,6           ;     1
rcall Wait05ms       ;   
dec XL
cpi XL,0
breq WD4
rjmp WD3
WD4:
ret 

WriteEEPROM:   ;       EEPROM

rcall Sound        ;     
rcall Wait500      ;    
mov EEdwr,EEdrd         ;    
	sei
    clr	t1
	out	TCCR0A,t1	    ;   0
	ldi	t1,1<<TOIE0
	out	TIMSK,t1		
	ldi	t1,Interval		;  0  10 
	out	TCNT0,t1		;    
	ldi	t1,5		    ;   
	out	TCCR0B,t1	    ;  1024 (Ck/1024 prescaling)
sbi	DDRD,4	            ;   IC2, IC3 
cbi	DDRB,4	            ;   
WriteEEPROM2:
clr  t1
in  t1,PIND        ;    SB1
sbrs t1,0          ;   ,    
rjmp ME0
rjmp ME1
ME0:
inc  EEdwr         ;   , UP
rcall Sound2       ;    
rcall Wait500      ;    
ME1:
clr  t1
in  t1,PIND        ;    SB3
sbrs t1,2          ;   ,    
rjmp ME2
rjmp ME3
ME2:
dec  EEdwr         ;   , DOWN
rcall Sound2       ;    
rcall Wait500      ;    
ME3:
mov HexL,EEdwr     ;  ,  
ldi t1,0
mov HexH,t1        ; ,  
rcall HexBCD       ;   BCD - 
rcall Code_31      ;    
clr  t1
in  t1,PIND        ;    SB2
sbrs t1,1          ;   ,    
rjmp ME4
rjmp ME5
ME4:
rcall EEWrite      ;      EEPROM
rcall Sound        ;    
rcall Wait500      ;    
ME5:
mov EEdrd,EEdwr    ;    
clr  t1
in  t1,PIND        ;    SB4
sbrs t1,5          ;   ,    
rjmp Main          ;    
rjmp WriteEEPROM2

EEWrite:		;  "  EEPROM"

    cli                 ;  
	sbic	EECR,EEPE	;  EEPE  . 0, 
	rjmp	EEWrite		;    
		                ;      EEPROM -
	out	EEAR, YL	    ;     
	out	EEDR,EEdwr	    ;   -    
	sbi	EECR,EEMPE	    ;  EEMPE  
	sbi	EECR,EEPE	    ;  EEPE :  
				        ;     4- ,  
			        	;     2 
    sei                 ;  
	ret

EERead:			;  " EEPROM"

    cli                 ;  
	sbic	EECR, EEPE	;  EEPE  . 0, 
	rjmp	EERead		;    
	           	        ;     EEPROM -
	out	EEAR, YL	    ;      
	sbi	EECR, EERE	    ;   EERE    .
				        ;   4 ,  
				        ;   2 
	in	EEdrd, EEDR	    ;   
    sei                 ;  
	ret
	      
Kath:       ;   

K0_1: .db 0b00010000,0b00110000         ;  0-1
K2_3: .db 0b01000000,0b01110000         ;  2-3
K4_5: .db 0b10010000,0b10110000         ;  4-5
K6_7: .db 0b11000000,0b11110000         ;  6-7

             ;  RAM
.dseg
  
D0: .byte 1   ;    1  , D0
D1: .byte 1   ;    2  ,D1
D2: .byte 1   ;    3  , D2
D3: .byte 1   ;    4  , D3
D4: .byte 1   ;    5  , D4
D5: .byte 1   ;    6  , D5
D6: .byte 1   ;    7  , D6
D7: .byte 1   ;    8  , D7
S0: .byte 1   ;  , , S0,   
S1: .byte 1   ;  , , S1
S2: .byte 1   ;  , , S2,   
S3: .byte 1   ;  , , S3
S4: .byte 1   ;  , , S4,      
S5: .byte 1   ;  , , S5,  


 ; END -   


